#pragma once

#include "CoreMinimal.h"
#include "Interfaces/IConfigParser.h"

class INJOYLAB_API CSVConfigParser : public IConfigParser
{
private:
    TArray<TArray<FString>> ParsedData; // 洢 CSV ݱά飩

public:
    CSVConfigParser();
    virtual ~CSVConfigParser() = default;

    //  CSV ļ
    virtual bool LoadConfig(const FString& FilePath) override;

    // ȡĳһе
    TArray<FString> GetRow(int32 RowIndex) const;

    // ȡĳһе
    TArray<FString> GetColumn(int32 ColumnIndex) const;

    // ȡĳԪ
    FString GetCell(int32 RowIndex, int32 ColumnIndex, const FString& DefaultValue = TEXT("")) const;

    // ȡֵַ "RowIndex.ColumnIndex"
    virtual FString GetString(const FString& Key, const FString& DefaultValue = TEXT("")) const override;

    // ȡֵ "RowIndex.ColumnIndex"
    virtual int32 GetInt(const FString& Key, int32 DefaultValue = 0) const override;

    // ȡֵ "RowIndex.ColumnIndex"
    virtual float GetFloat(const FString& Key, float DefaultValue = 0.0f) const override;

    // ȡֵ "RowIndex.ColumnIndex"
    virtual bool GetBool(const FString& Key, bool DefaultValue = false) const override;

    // ȡֵĳһУ
    virtual TArray<FString> GetArray(const FString& Key) const override;

    // ȡӶ󣨷ĳһУ
    virtual TSharedPtr<IConfigParser> GetObject(const FString& Key) const override;

    // ӡ CSV ݣã
    virtual void PrintConfig() const override;
};