#pragma once

#include "CoreMinimal.h"
#include "Interfaces/IConfigParser.h"

class INJOYLAB_API JsonConfigParser : public IConfigParser
{
private:
    TSharedPtr<FJsonObject> ParsedData; // 洢 JSON 

    // ݲλ JSON 
    TSharedPtr<FJsonValue> FindJsonValue(const FString& Key) const;

public:
    virtual ~JsonConfigParser() = default;

    //  JSON ļ
    virtual bool LoadConfig(const FString& FilePath) override;

    // ȡֵַ
    virtual FString GetString(const FString& Key, const FString& DefaultValue = TEXT("")) const override;

    // ȡֵ
    virtual int32 GetInt(const FString& Key, int32 DefaultValue = 0) const override;

    // ȡֵ
    virtual float GetFloat(const FString& Key, float DefaultValue = 0.0f) const override;

    // ȡֵ
    virtual bool GetBool(const FString& Key, bool DefaultValue = false) const override;

    // ȡֵ
    virtual TArray<FString> GetArray(const FString& Key) const override;

    // ȡӶ
    virtual TSharedPtr<IConfigParser> GetObject(const FString& Key) const override;

    // ӡ
    virtual void PrintConfig() const override;

    //  JSON ص UStruct
    template <typename StructType>
    bool LoadStruct(const FString& FilePath, StructType& OutStruct);

    //  UStruct Ϊ JSON ļ
    template <typename StructType>
    bool SaveStruct(const StructType& InStruct, const FString& FilePath);

    //  JSON ص TArray<UStruct>
    template <typename StructType>
    bool LoadArrayStruct(const FString& FilePath, TArray<StructType>& OutArray);

    template <typename StructType>
    bool SaveArrayStruct(const TArray<StructType>& InArray, const FString& FilePath);
};